library platforms_source_gen;

import 'dart:io';
import 'dart:convert';

import 'android_gen.dart';

void main(){
  platforms_source_gen_init("./lib/example/example.dart",//you dart file path
      "com.siyehua.example",//your android's  java class package name
      "./Android_gen" //your android file save path
  );
}
void platforms_source_gen_init(String path, String javaPackage, String androidSavePath) async {
  // String path = "./lib/example/example.dart";
  // String javaPackage = "com.siyehua.example";
  // String androidSavePath = "./Android_gen";

  List<String> importList = [];
  Map<String, List<String>> classMap = {};
  List<String> tmpPropertyList = [];
  await new File(path)
      .openRead()
      .transform(utf8.decoder)
      .transform(new LineSplitter())
      .forEach((str) {
    // print('read line: $str');
    if (_checkLineStr(str)) {
    } else if (_foundImport(str, importList)) {
    } else if (_foundClassName(str, classMap, tmpPropertyList)) {
    } else {
      _formatLine(str, tmpPropertyList);
    }
  });
  // print(classMap);
  JavaCreate.create(javaPackage, androidSavePath, classMap);
}

bool _checkLineStr(String str) {
  str = str.replaceAll("\t", "").replaceAll("\n", "").trim();
  if (str.startsWith("//") || str.isEmpty) {
    return true;
  }
  return false;
}

bool _foundImport(String str, List<String> importList) {
  if (str.startsWith("import")) {
    importList.add(str);
    return true;
  }
  return false;
}

String tmpClassNameStr = "";

bool _foundClassName(String str, Map<String, List<String>> classMap,
    List<String> tmpPropertyList) {
  if (str.startsWith("class")) {
    tmpClassNameStr = str.replaceAll("class", "").replaceAll("{", "").trim();
    // print("class str: " + str + " name:" + tmpClassNameStr);
    return true;
  } else if (str == "}") {
    // print("class end: " + str + " name:" + tmpClassNameStr);

    List<String> data = [];
    data.addAll(tmpPropertyList);
    classMap[tmpClassNameStr] = data;

    //clear cache
    tmpPropertyList.clear();
    tmpClassNameStr = "";
    tmpLineStr = "";

    return true;
  }
  return false;
}

String tmpLineStr = "";

void _formatLine(String str, List<String> tmpPropertyList) {
  //pattern line end
  RegExp exp = new RegExp(r";[ ]*//|;");
  if (!exp.hasMatch(str)) {
    //the line is't end, so continue...

    tmpLineStr += str;
  } else {
    // print("property str: " + tmpLineStr + str);
    int endIndex = str.lastIndexOf(";");
    str = str.substring(0, endIndex);
    str = tmpLineStr + str;
    str = str.replaceAll("new", "");
    str = str.trimLeft().trimRight().trim();
    tmpPropertyList.add(str);
    tmpLineStr = ""; //clear tmp str
  }
}
